/***************************************************************************
 *            ClientsInfoNoteBookTab.h
 *
 *  Mon Sep 10 00:35:32 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _CLIENTSINFONOTEBOOKTAB_H
#define _CLIENTSINFONOTEBOOKTAB_H

#include "gtkmm.h"

#include "Utils.h"

#include "Lince/Torrent.h"

class TorrentInfoTab;
typedef std::map<libtorrent::peer_id, libtorrent::peer_info> PeerMap;

class ClientsInfoNoteBookTab : public Gtk::ScrolledWindow{
	private:
		Glib::ustring nameTab;
			
		class ClientModelColumns : public Gtk::TreeModel::ColumnRecord{
			public:
				ClientModelColumns() {add(m_client_flag); add(m_client_ip); add(m_client_country); add(m_client_name);
				add(m_client_connection_type); add(m_client_percentage); add(m_client_up_speed); add(m_client_down_speed);
				add(m_client_state); add(m_client_up_data); add(m_client_down_data); add(m_up_speed); add(m_down_speed);
				add(m_up_data); add(m_down_data); add(has_flag); add(m_pid); add(remove);}
			
				Gtk::TreeModelColumn< Glib::RefPtr<Gdk::Pixbuf> > m_client_flag;
				Gtk::TreeModelColumn<Glib::ustring> m_client_ip;
				Gtk::TreeModelColumn<Glib::ustring> m_client_country;
				Gtk::TreeModelColumn<Glib::ustring> m_client_name;
				Gtk::TreeModelColumn<Glib::ustring> m_client_connection_type;
				Gtk::TreeModelColumn<float> m_client_percentage;
				Gtk::TreeModelColumn<Glib::ustring> m_client_up_speed;
				Gtk::TreeModelColumn<Glib::ustring> m_client_down_speed;
				Gtk::TreeModelColumn<Glib::ustring> m_client_state;
				Gtk::TreeModelColumn<Glib::ustring> m_client_up_data;
				Gtk::TreeModelColumn<Glib::ustring> m_client_down_data;
				// Sort Columns
				Gtk::TreeModelColumn<float> m_up_speed;
				Gtk::TreeModelColumn<float> m_down_speed;
				Gtk::TreeModelColumn<float> m_up_data;
				Gtk::TreeModelColumn<float> m_down_data;
				// Management Data
				Gtk::TreeModelColumn<bool> has_flag;
				Gtk::TreeModelColumn<bool> remove;
				Gtk::TreeModelColumn<libtorrent::peer_id> m_pid;
		};
	
		ClientModelColumns clientsColumns;
		// Rows 
		Gtk::TreeView clientsTreeView;
		Glib::RefPtr<Gtk::ListStore> refTreeModel;
	
		// Show columns_autosize
		Glib::RefPtr<Gtk::ToggleAction> showFlag;
		Glib::RefPtr<Gtk::ToggleAction> showIp;
		Glib::RefPtr<Gtk::ToggleAction> showCountry;
		Glib::RefPtr<Gtk::ToggleAction> showClient;
		Glib::RefPtr<Gtk::ToggleAction> showConnectionType;
		Glib::RefPtr<Gtk::ToggleAction> showPercentage;
		Glib::RefPtr<Gtk::ToggleAction> showUSpeed;
		Glib::RefPtr<Gtk::ToggleAction> showDSpeed;
		Glib::RefPtr<Gtk::ToggleAction> showState;
		Glib::RefPtr<Gtk::ToggleAction> showUData;
		Glib::RefPtr<Gtk::ToggleAction> showDData;
	
		Glib::RefPtr<Gtk::ActionGroup> m_refActionGroup;
	
		// Menu client selected
		Glib::RefPtr<Gtk::UIManager> refUIManager;
		Gtk::Menu* pMenuPopup;
	
		// Menu without client selected
		Glib::RefPtr<Gtk::UIManager> n_refUIManager;
		Gtk::Menu* n_pMenuPopup;
		
		// TorrentInfoTab pointer
		TorrentInfoTab *tit;
	
		void updateRow(const libtorrent::peer_info &, Gtk::TreeModel::Row &);
		void unselectRows();
	
		bool isRowSelected();
	
		void banClient(int);
		void mouse_button_press_event(GdkEventButton* event);
		void hideColumn(int);
		
	public:
		ClientsInfoNoteBookTab(TorrentInfoTab *);
		~ClientsInfoNoteBookTab();
	
		const Glib::ustring & getNameTab() { return nameTab; };
		void updateClientsInfoNoteBookTab(Lince::Torrent *);
	
		virtual Gtk::Widget * getTabChild(void) { return this; };
};

#endif /* _CLIENTSINFONOTEBOOKTAB_H */

 
