/***************************************************************************
 *            FilesInfoNoteBookTab.h
 *
 *  Mon Sep 10 00:49:59 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _FILESINFONOTEBOOKTAB_H
#define _FILESINFONOTEBOOKTAB_H

#include "gtkmm.h"

#include "Utils.h"

#include "Lince/Torrent.h"

class FilesInfoNoteBookTab: public Gtk::ScrolledWindow{
	private:
		Glib::ustring nameTab;
	
		class FilesModelColumns : public Gtk::TreeModel::ColumnRecord{
			public:
				FilesModelColumns() { add(m_file_firstpiece); add(m_file_lastpiece); add(m_file_name);
					add(m_file_percentage); add(m_file_size); add(m_file_priority); add(file_size);}
			
				Gtk::TreeModelColumn<int> m_file_firstpiece;
				Gtk::TreeModelColumn<int> m_file_lastpiece;
				Gtk::TreeModelColumn<Glib::ustring> m_file_name;
				Gtk::TreeModelColumn<Glib::ustring> m_file_size;
				Gtk::TreeModelColumn<int> m_file_percentage;
				Gtk::TreeModelColumn<Glib::ustring> m_file_priority;
				// Sort Column
				Gtk::TreeModelColumn<int> file_size;
				
		};
	
		FilesModelColumns filesColumns;
		// Rows 
		Gtk::TreeView filesTreeView;
		Glib::RefPtr<Gtk::ListStore> refTreeModel;
	
		bool isModelFilled;
		// Used to update percentage just when needed
		int downloadedPieces;
	
		int getFilePercentage(int, int, const libtorrent::bitfield *);
	
		void unselectRows();
	
	public:
		FilesInfoNoteBookTab();
		~FilesInfoNoteBookTab();
	
		const Glib::ustring & getNameTab() { return nameTab; };
		void updateFilesInfoNoteBookTab(Lince::Torrent *);
	
		virtual Gtk::Widget * getTabChild(void) { return this; };
};

#endif /* _FILESINFONOTEBOOKTAB_H */

 
