//           StatisticsTab.cc
//  Sat Dec 22 13:50:55 2007
//  Copyright  2007  Fernando Tarín Morales
//  icemanf@gmail.com

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA

#include "StatisticsTab.h"

#include "../config.h"
#include <glibmm/i18n.h>

StatisticsTab::StatisticsTab():
	BaseTab(_("Statistics")),
	Gtk::Notebook()
{
	set_name("statisticsNotebook");
	set_border_width(0);
    set_show_tabs(true);
	set_show_border(true);
    set_show_border(false);
	set_scrollable(false);
		
    set_tab_pos(Gtk::POS_TOP);
	
	set_border_width(0);
	property_tab_hborder() = 0;
	property_tab_vborder() = 0;
	property_can_focus() = false;
	
	isGraphStatsShown = true;
	
	append_page(*graphTab.getTabChild(), graphTab.getNameTab());
	append_page(*dataTab.getTabChild(), dataTab.getNameTab());
}

void StatisticsTab::showGraphStats(bool value)
{
	if (isGraphStatsShown == value) 
		return;
	else
		isGraphStatsShown = value;
	
	if (!value)
		remove_page(0);
	else
		insert_page(*graphTab.getTabChild(), graphTab.getNameTab(), 0);
}

StatisticsTab::~StatisticsTab(){
}
