/***************************************************************************
 *            StatusBar.h
 *
 *  Tue Feb 27 23:55:29 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#ifndef _STATUSBAR_H
#define _STATUSBAR_H

#include <gtkmm.h>

class StatusBar: public Gtk::Statusbar{
	public:
		enum status { GOOD, FIREWALLED, NO_CONNECTION, SEEDING };

		Gtk::HBox statusHBox;

		void setStatus(status);
		void setUpSpeed(float);
		void setDownSpeed(float);

		void setMaxUpSpeed(float);
		void setMaxDownSpeed(float);

		void setConnectionsNum(int);
		void setMaxConnections(int);

		void setDhtStatus(bool, int, int);

		StatusBar();
		~StatusBar();
	private:
		Gtk::Label statusGoodLabel, statusFirewalledLabel, statusNoConnectionLabel, statusSeedingLabel;
		Gtk::Image statusGoodImage, statusNoConnectionImage, statusFirewalledImage, statusSeedingImage;

		Gtk::Label upLabel, downLabel;
		Gtk::Image upImage, downImage;

		Gtk::Label connectionsLabel, connectionsValue, maxConnectsValue;
		Gtk::Image connectionsImage;

		Gtk::Label upValueLabel, downValueLabel;
		Gtk::Label maxUpValueLabel, maxDownValueLabel;

		Gtk::Label dhTLabel, dhtStatusLabel;
};

#endif /* _STATUSBAR_H */
